﻿Imports System.IO
Imports System.Net
Imports Renci.SshNet
Imports guinet

Public Class guixtftp

    Dim myguixt As New guinet.guixt

    Public Function ReadDirectory(hostname As String, username As String,
                                  password As String, directory As String,
                                  guixtvariable As String) As String

        Dim r As String = ""
        Try

            Dim myftp As New Renci.SshNet.SftpClient(hostname, username, password)
            myftp.Connect()

            Dim c As Integer = 1

            Dim list As List(Of Sftp.SftpFile) = CType(myftp.ListDirectory(directory),
                List(Of Sftp.SftpFile))

            For Each sFile As Sftp.SftpFile In list

                If Not sFile.IsDirectory() Then
                    myguixt.SetVariable(guixtvariable & ".filename." & c.ToString, sFile.FullName)
                    c += 1
                End If

            Next

            myftp.Disconnect()

        Catch ex As Exception
            r = ex.Message
        End Try

        Return r


    End Function


    Public Function DownloadFile(hostname As String, username As String,
                                  password As String, filename As String,
                                  savetopath As String) As String

        Dim tempPath = System.IO.Path.GetTempPath()

        Dim r As String = ""
        Try

            Dim myftp As New Renci.SshNet.SftpClient(hostname, username, password)
            myftp.Connect()

            Using fs As New FileStream(savetopath, FileMode.Create, FileAccess.Write)
                myftp.DownloadFile(filename, fs)
            End Using

            myftp.Disconnect()

        Catch ex As Exception
            r = ex.Message
        End Try

        Return r

    End Function

End Class
